"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Protobuf message definitions for transferring Station Control settings tree."""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import iqm.data_definitions.common.v1.data_types_pb2
import iqm.data_definitions.common.v1.parameter_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class SingleParameterSweep(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARAMETER_NAME_FIELD_NUMBER: builtins.int
    VALUES_FIELD_NUMBER: builtins.int
    PARAMETER_FIELD_NUMBER: builtins.int
    parameter_name: builtins.str
    """Represents a sweep over several values of a single parameter.
    Values can be repeated, so that a single ParallelSweep can be used to describe an arbitrary sequence of sweep spots.
    This makes CartesianSweep somewhat redundant, but it can be more convenient to the user.
    """
    @property
    def values(self) -> iqm.data_definitions.common.v1.data_types_pb2.Sequence: ...
    @property
    def parameter(self) -> iqm.data_definitions.common.v1.parameter_pb2.Parameter: ...
    def __init__(
        self,
        *,
        parameter_name: builtins.str = ...,
        values: iqm.data_definitions.common.v1.data_types_pb2.Sequence | None = ...,
        parameter: iqm.data_definitions.common.v1.parameter_pb2.Parameter | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["_parameter", b"_parameter", "parameter", b"parameter", "values", b"values"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["_parameter", b"_parameter", "parameter", b"parameter", "parameter_name", b"parameter_name", "values", b"values"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["_parameter", b"_parameter"]) -> typing.Literal["parameter"] | None: ...

global___SingleParameterSweep = SingleParameterSweep

@typing.final
class ParallelSweep(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SINGLE_PARAMETER_SWEEPS_FIELD_NUMBER: builtins.int
    @property
    def single_parameter_sweeps(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___SingleParameterSweep]:
        """The sweep spots of a ParallelSweep are the parallel pairing of the spots of the constituent SingleParameterSweeps,
        zip(x, y, ...) == [(x1, y1, ...), (x2, y2, ...), ..., (xmax, ymax, ...)]. The SingleParameterSweeps have to be equally long.
        """

    def __init__(
        self,
        *,
        single_parameter_sweeps: collections.abc.Iterable[global___SingleParameterSweep] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["single_parameter_sweeps", b"single_parameter_sweeps"]) -> None: ...

global___ParallelSweep = ParallelSweep

@typing.final
class CartesianSweep(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PARALLEL_SWEEPS_FIELD_NUMBER: builtins.int
    @property
    def parallel_sweeps(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ParallelSweep]:
        """The sweep spots of an CartesianSweep are the cartesian product of the spots of the ParallelSweeps it contains.
        parallel_sweeps == [x, ..., y, z] => spots == cartesian_product(x, ..., y, z)
        == [(x1, ..., y1, z1), ..., (x1, ..., y1, zmax), (x1, ..., y2, z1), ..., (xmax, ..., ymax, zmax)].
        In all kinds of sweeps the iteration order of the sweep spots is big-endian, i.e. the first listed parameter changes the slowest.
        No parameter may appear more than once in an CartesianSweep (because otherwise its value would not be well-defined).
        """

    def __init__(
        self,
        *,
        parallel_sweeps: collections.abc.Iterable[global___ParallelSweep] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["parallel_sweeps", b"parallel_sweeps"]) -> None: ...

global___CartesianSweep = CartesianSweep
