"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file

Request to Station Control, fully defining what should be executed.
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import google.protobuf.struct_pb2
import iqm.data_definitions.common.v1.playlist_pb2
import iqm.data_definitions.common.v1.setting_pb2
import iqm.data_definitions.common.v1.sweep_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class SweepRequest(google.protobuf.message.Message):
    """The instructions required to perform a sweep."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class AwgsToPlaylistsAsJsonEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        value: builtins.str
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: builtins.str = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    SWEEP_ID_FIELD_NUMBER: builtins.int
    SETTINGS_FIELD_NUMBER: builtins.int
    SWEEPS_FIELD_NUMBER: builtins.int
    RETURN_PARAMETERS_FIELD_NUMBER: builtins.int
    AWGS_TO_PLAYLISTS_AS_JSON_FIELD_NUMBER: builtins.int
    DUT_LABEL_FIELD_NUMBER: builtins.int
    PLAYLIST_FIELD_NUMBER: builtins.int
    RUN_METADATA_FIELD_NUMBER: builtins.int
    sweep_id: builtins.str
    """Unique identifier (UUID) of the sweep."""
    dut_label: builtins.str
    """Describes which DUT of the station control should be used."""
    @property
    def settings(self) -> iqm.data_definitions.common.v1.setting_pb2.SettingNode:
        """Initial settings that define the state of the devices."""

    @property
    def sweeps(self) -> iqm.data_definitions.common.v1.sweep_pb2.CartesianSweep:
        """Describes which parameters in settings to iterate over."""

    @property
    def return_parameters(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Which parameters to read from the instruments and save to the database."""

    @property
    def awgs_to_playlists_as_json(self) -> google.protobuf.internal.containers.ScalarMap[builtins.str, builtins.str]:
        """Mapping from each AWG to the corresponding Playlist. The format is serialized as JSON, to be replaced with a proto."""

    @property
    def playlist(self) -> iqm.data_definitions.common.v1.playlist_pb2.Playlist:
        """Sequence of instruction schedules to run on the instruments for each sweep spot."""

    @property
    def run_metadata(self) -> global___RunMetadata:
        """Obsolescent metadata about a run that Exa needs to save."""

    def __init__(
        self,
        *,
        sweep_id: builtins.str = ...,
        settings: iqm.data_definitions.common.v1.setting_pb2.SettingNode | None = ...,
        sweeps: iqm.data_definitions.common.v1.sweep_pb2.CartesianSweep | None = ...,
        return_parameters: collections.abc.Iterable[builtins.str] | None = ...,
        awgs_to_playlists_as_json: collections.abc.Mapping[builtins.str, builtins.str] | None = ...,
        dut_label: builtins.str | None = ...,
        playlist: iqm.data_definitions.common.v1.playlist_pb2.Playlist | None = ...,
        run_metadata: global___RunMetadata | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["_dut_label", b"_dut_label", "_run_metadata", b"_run_metadata", "dut_label", b"dut_label", "playlist", b"playlist", "run_metadata", b"run_metadata", "settings", b"settings", "sweeps", b"sweeps"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["_dut_label", b"_dut_label", "_run_metadata", b"_run_metadata", "awgs_to_playlists_as_json", b"awgs_to_playlists_as_json", "dut_label", b"dut_label", "playlist", b"playlist", "return_parameters", b"return_parameters", "run_metadata", b"run_metadata", "settings", b"settings", "sweep_id", b"sweep_id", "sweeps", b"sweeps"]) -> None: ...
    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal["_dut_label", b"_dut_label"]) -> typing.Literal["dut_label"] | None: ...
    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal["_run_metadata", b"_run_metadata"]) -> typing.Literal["run_metadata"] | None: ...

global___SweepRequest = SweepRequest

@typing.final
class RunMetadata(google.protobuf.message.Message):
    """
    Metadata about a run that Exa needs to save.
    Currently passed to Station Control for saving purposes, but not used by Station Control.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class HardSweepsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> iqm.data_definitions.common.v1.sweep_pb2.CartesianSweep: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: iqm.data_definitions.common.v1.sweep_pb2.CartesianSweep | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    RUN_ID_FIELD_NUMBER: builtins.int
    COMPONENTS_FIELD_NUMBER: builtins.int
    DEFAULT_SWEEP_PARAMETERS_FIELD_NUMBER: builtins.int
    DEFAULT_DATA_PARAMETERS_FIELD_NUMBER: builtins.int
    HARD_SWEEPS_FIELD_NUMBER: builtins.int
    ADDITIONAL_RUN_PROPERTIES_FIELD_NUMBER: builtins.int
    run_id: builtins.str
    """Run ID of the EXA experiment. Used to link the Sweep request ID to a run."""
    @property
    def components(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Chip components (qubits, couplers) that are active in the request."""

    @property
    def default_sweep_parameters(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Which of the parameters in `sweep` were added by default. The rest were added by user."""

    @property
    def default_data_parameters(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Which of the parameters in `return_parameters` were added by default. The rest were added by user."""

    @property
    def hard_sweeps(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, iqm.data_definitions.common.v1.sweep_pb2.CartesianSweep]: ...
    @property
    def additional_run_properties(self) -> google.protobuf.struct_pb2.Struct:
        """Other, freeform fields."""

    def __init__(
        self,
        *,
        run_id: builtins.str = ...,
        components: collections.abc.Iterable[builtins.str] | None = ...,
        default_sweep_parameters: collections.abc.Iterable[builtins.str] | None = ...,
        default_data_parameters: collections.abc.Iterable[builtins.str] | None = ...,
        hard_sweeps: collections.abc.Mapping[builtins.str, iqm.data_definitions.common.v1.sweep_pb2.CartesianSweep] | None = ...,
        additional_run_properties: google.protobuf.struct_pb2.Struct | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["additional_run_properties", b"additional_run_properties"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["additional_run_properties", b"additional_run_properties", "components", b"components", "default_data_parameters", b"default_data_parameters", "default_sweep_parameters", b"default_sweep_parameters", "hard_sweeps", b"hard_sweeps", "run_id", b"run_id"]) -> None: ...

global___RunMetadata = RunMetadata
