"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file

Station Task definition.
"""

import builtins
import collections.abc
import google.protobuf.any_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import iqm.data_definitions.common.v1.data_types_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class SweepTaskRequest(google.protobuf.message.Message):
    """
    A task to the queue of Station Control service. Contains data related to the queuing, and the sweep request as a
    payload.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    QUEUE_NAME_FIELD_NUMBER: builtins.int
    PAYLOAD_FIELD_NUMBER: builtins.int
    SWEEP_ID_FIELD_NUMBER: builtins.int
    queue_name: builtins.str
    """Name of the destination queue."""
    sweep_id: builtins.str
    """Identifier of the sweep. Should be same as the ID contained in `payload`, but we include it here separately so
    that the payload does not have to be deserialized to see the ID.
    """
    @property
    def payload(self) -> google.protobuf.any_pb2.Any:
        """The sweep_request as serialized bitstring. We want to keep it encoded such that it does not need to be unpacked
        while the data related to queuing is processed.
        """

    def __init__(
        self,
        *,
        queue_name: builtins.str = ...,
        payload: google.protobuf.any_pb2.Any | None = ...,
        sweep_id: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["payload", b"payload"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["payload", b"payload", "queue_name", b"queue_name", "sweep_id", b"sweep_id"]) -> None: ...

global___SweepTaskRequest = SweepTaskRequest

@typing.final
class SweepResultsResponse(google.protobuf.message.Message):
    """Response body for GET /sweeps/{uuid}/results"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class ResultsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> iqm.data_definitions.common.v1.data_types_pb2.Array: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: iqm.data_definitions.common.v1.data_types_pb2.Array | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    SWEEP_ID_FIELD_NUMBER: builtins.int
    RESULTS_FIELD_NUMBER: builtins.int
    sweep_id: builtins.str
    """A UUID that gives identity to the sweep event."""
    @property
    def results(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, iqm.data_definitions.common.v1.data_types_pb2.Array]:
        """Maps the names of SweepRequest.return_parameters to corresponding results arrays.
        The array shape is [s_1, s_2, ..., s_m, r], where `s_k` is the number of sweep
        spots in the k:th ParallelSweep, and `r` is the result_length of the corresponding return_parameter for one spot.
        All Arrays in `results` have the same shape except for `r`.
        """

    def __init__(
        self,
        *,
        sweep_id: builtins.str = ...,
        results: collections.abc.Mapping[builtins.str, iqm.data_definitions.common.v1.data_types_pb2.Array] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["results", b"results", "sweep_id", b"sweep_id"]) -> None: ...

global___SweepResultsResponse = SweepResultsResponse
